package info.aspirecn.iov.yysj.check.info.common;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.netflix.zuul.context.RequestContext;
import info.aspirecn.iov.yysj.check.info.entity.TokenResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;


@Component
@Slf4j
public class AuthenChannelRibbonHandle {
	@Resource(name = "getRestTemplate")
	RestTemplate restTemplate;
	@Autowired
	ObjectMapper objectMapper;
	@Autowired
	Property property;

	public TokenResponse channelRibbonHandle(String appId, String appSecret) {

		TokenResponse responseObject = new TokenResponse();
		try{
			RequestContext.getCurrentContext().set("connectTimeout", property.getConnetTimeOut());
			RequestContext.getCurrentContext().set("readTimeout", property.getReadTimeOut()+1000);
			Map<String, String> uriVariables = new HashMap<String, String>();
			uriVariables.put("appid",appId);
			uriVariables.put("appsecret",appSecret);
			String url = property.getAuthenUrl()+"?appid="+appId+"&appsecret="+appSecret;
			log.info("url:{}",url);
			ResponseEntity<TokenResponse> entity =  restTemplate.getForEntity(url, TokenResponse.class);
			if (entity != null && entity.getStatusCode() == HttpStatus.OK) {// 调用通道成功
				responseObject = entity.getBody();
			}
		} catch (Exception ex) {
			log.error("Exception:{}",ex);
		}
		return responseObject;
	}
}
