package info.aspirecn.iov.yysj.check.info.common;

import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import javax.annotation.Resource;

import info.aspirecn.cloud.yysj.commons.lang.BillItemResult;
import info.aspirecn.cloud.yysj.commons.lang.Constants;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.netflix.zuul.context.RequestContext;
import lombok.extern.slf4j.Slf4j;


@Component
@Slf4j
public class ChannelRibbonHandle {
	@Resource(name = "getRestTemplate")
	RestTemplate restTemplate;
	@Autowired
	ObjectMapper objectMapper;
	@Autowired
	Property property;

	public BillItemResult channelRibbonHandle(String  token, String body, String userId, String yysjTraceId, String yysjProductId) {
		BillItemResult billItemResult = new BillItemResult();
		BillItemResult.ErrorResponse errorResponse =new BillItemResult.ErrorResponse();
		billItemResult.setResult(Constants.inconsistent_code);
		log.info("body:{},token:{},yysjTraceId:{}",body,token,yysjTraceId);
		try{
				RequestContext.getCurrentContext().set("connectTimeout", property.getConnetTimeOut());
				RequestContext.getCurrentContext().set("readTimeout", property.getReadTimeOut()+1000);
			HttpHeaders headers = new HttpHeaders();

			restTemplate.getMessageConverters().set(1,new StringHttpMessageConverter(StandardCharsets.UTF_8));
			MediaType type = MediaType.parseMediaType("application/json;charset=UTF-8");
			headers.setContentType(type);
			headers.add(Constants.HEADER_ACCEPT_KEY, MediaType.APPLICATION_JSON.toString());
			headers.add(Constants.HEADER_TOKEN_KEY, token);
			headers.add(Constants.USER_ID_KEY, userId);
			headers.add("yysjProductId",yysjProductId);
			//headers.add(Constants.HEADER_OLD_TRACEID_KEY, yysjTraceId);
			headers.add(Constants.HEADER_PARENT_TRACEID_KEY, yysjTraceId);
			Map<String, String> uriVariables = new HashMap<String, String>();
			HttpEntity <String>httpEntity =null;
			Map<String, String> httpBody = new HashMap<String, String>();
			ResponseEntity<BillItemResult> entity = null;
				httpEntity = new HttpEntity<String>(body,
						headers);
				entity = restTemplate.postForEntity(property.getGateWayUrl(), httpEntity,
						BillItemResult.class,new HashMap());

			if (entity != null && entity.getStatusCode() == HttpStatus.OK) {// 调用通道成功
				billItemResult = entity.getBody();
			}
			log.info("billItemResult:{}",billItemResult);

		} catch (Exception ex) {
			log.error("Exception:{}",ex);
			errorResponse.setCode(Constants.ErrorCode.Exception.getErrorCode());
			billItemResult.setExceptionInformation(errorResponse);
		}
		return billItemResult;
	}
}
