package info.aspirecn.iov.yysj.check.info.common;

import com.netflix.zuul.context.RequestContext;
import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.iov.yysj.check.info.entity.RequestBody;
import info.aspirecn.iov.yysj.paramtransfer.inter.common.Constant;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.http.HttpServletRequest;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

@Slf4j
public class CommonUtil {
    private static List<String> allowUrls=null;
    //获取请求内容
    public static String getBody(HttpServletRequest request){
        String bodyStr =null;
        try {
            StringBuffer body = new StringBuffer();
            BufferedReader bufferedReader = new BufferedReader(
                    new InputStreamReader(request.getInputStream(), "utf-8")); // 读取参数流
            String nextLine = bufferedReader.readLine();
            while (nextLine != null) {
                body.append(nextLine);
                nextLine = bufferedReader.readLine();
            }
            bodyStr = body.toString();
            if (bodyStr == null || bodyStr.length() <= 0) {
                log.error("请求参数为空,bodyStr:{}",bodyStr);
            }
        }catch (Exception ex){
            log.error("获取参数异常,ex:{}",ex);
        }
        return  bodyStr;
    }
    //xml转对象
    public static RequestBody xmlTojava(String xml, Class cls) throws Exception {
        // 获取JAXB的上下文环境，需要传入具体的 Java bean -> 这里使用Student
        JAXBContext context = JAXBContext.newInstance(RequestBody.class);
        // 创建 UnMarshaller 实例
        Unmarshaller unmarshaller = context.createUnmarshaller();
        // 加载需要转换的XML数据 -> 这里使用InputStream，还可以使用File，Reader等
/*        String str= "<ROOT><Headers><X-Ca-Key>111</X-Ca-Key><X-Ca-Timestamp>111111</X-Ca-Timestamp><X-Ca-Nonce>111111</X-Ca-Nonce>"
                +"<X-Ca-Signature>111111</X-Ca-Signature>"
                +"<Accept>111111</Accept>"
                +"<Content-Type>111111</Content-Type>"
                +"<Content-MD5>111111</Content-MD5>"
                +"</Headers>"
                +"<Body>111111</Body></ROOT>";*/
        ByteArrayInputStream byteArrayInputStream = new ByteArrayInputStream(xml.getBytes());
        InputStream inputStream=(InputStream)byteArrayInputStream;
        // 将XML数据序列化 -> 该方法的返回值为Object基类，需要强转类型
        RequestBody requestBody = (RequestBody) unmarshaller.unmarshal(inputStream);
        return  requestBody;
    }
    //获取请求url
    public static boolean checkUrl(String url){
       Constants.RequestUrl[] requestUrls = Constants.RequestUrl.values();

       for(Constants.RequestUrl requestUrl : requestUrls){
           if(requestUrl.getValue().equals(url)){
               return true;
           }
       }
        return false;
    }
    //校验道路运输url
    public static boolean checkRoadTransUrl(String url){
       Constants.RoadTransportUrl[] requestUrls = Constants.RoadTransportUrl.values();

       for(Constants.RoadTransportUrl requestUrl : requestUrls){
           if(requestUrl.getValue().equals(url)){
               return true;
           }
       }
        return false;
    }

    // 校验车辆轨迹url
    public static boolean checkVehicleTrajectoryUrl(String url) {
        Constants.VehicleTrajectoryUrl[] requestUrls = Constants.VehicleTrajectoryUrl.values();
        for(Constants.VehicleTrajectoryUrl requestUrl : requestUrls){
            if(requestUrl.getValue().equals(url)){
                return true;
            }
        }
        return false;
    }
    //获取所有请求url
    public static boolean checkAllUrl(String url){
        Constants.RequestUrl[] requestUrls = Constants.RequestUrl.values();

        for(Constants.RequestUrl requestUrl : requestUrls){
            if(requestUrl.getValue().equals(url)){
                return true;
            }
        }
        Constants.OtherRquestUrl[] otherRequestUrls = Constants.OtherRquestUrl.values();
        for(Constants.OtherRquestUrl requestUrl : otherRequestUrls){
            if(requestUrl.getValue().equals(url)){
                return true;
            }
        }
        Constants.VehicleTrajectoryUrl[] vehicleTrajectoryUrlUrls = Constants.VehicleTrajectoryUrl.values();
        for(Constants.VehicleTrajectoryUrl requestUrl : vehicleTrajectoryUrlUrls){
            if(requestUrl.getValue().equals(url)){
                return true;
            }
        }
        return false;
    }

    //获取请求type
    public static String getCheckType(String url){
        if(Constants.RequestUrl.CARURL.getValue().equals(url)){
            return "1";
        }else if(Constants.RequestUrl.DRIVERURL.getValue().equals(url)){
            return "3";
        }else if(Constants.RequestUrl.BILLWAYURL.getValue().equals(url)){
            return "2";
        }
        return "1";
    }
    //是否继续
    public static boolean isContinue(){
        Boolean flag = (Boolean)RequestContext.getCurrentContext().get("process");
        if(flag!=null && !flag){
            return false;
        }
        return true;
    }
}
