package info.aspirecn.iov.yysj.check.info.common;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.FIELD)
@Retention(RetentionPolicy.RUNTIME)
public @interface NonFixedValueAttr {
	/**
	 * 是否为可选属性
	 * true-可选 false-必须
	 * 默认true
	 */
	boolean isOptional() default true;
	/**
	 * 是否为手机号
	 * 默认false
	 */
	boolean isMobile() default false;
	/**
	 * 是否为IP地址
	 * 默认false
	 */
	boolean isIp() default false;
	/**
	 * 是否为日期
	 * 默认false
	 */
	boolean isDate() default false;
	/**
	 * 是否为数字
	 * 默认false
	 */
	boolean isNumber() default false;
	/**
	 * 日期的格式
	 * 默认yyyyMMddHHmmss
	 */
	String dateFormatString() default "yyyyMMddHHmmss";
	/**
	 * 正则表达式校验
	 * ""-不校验 不是""-校验
	 * 默认""
	 */
	String regularFormatString() default "";
	/**
	 * 属性最小长度
	 * 默认0
	 */
	int minLength() default 0;
	/**
	 * 属性最大长度
	 * 默认1024
	 */
	int maxLength() default 2147483647;
	
	/**
	 * 是否为url，默认不是
	 * @return
	 */
	boolean isUrl() default false;













}