package info.aspirecn.iov.yysj.check.info.common;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.netflix.zuul.context.RequestContext;
import info.aspirecn.cloud.yysj.commons.lang.BillItemResult;
import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.cloud.yysj.commons.lang.OtherCommonResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;


@Component
@Slf4j
public class OtherRibbonHandle {
	@Resource(name = "getRestTemplate")
	RestTemplate restTemplate;
	@Autowired
	ObjectMapper objectMapper;
	@Autowired
	Property property;

	public OtherCommonResult channelRibbonHandle( String  token, String body, String userId, String yysjTraceId, String yysjProductId) {
		log.info("body:{},token:{},yysjTraceId:{}",body,token,yysjTraceId);
		OtherCommonResult otherCommonResult = new OtherCommonResult();
		try{

				RequestContext.getCurrentContext().set("connectTimeout", property.getConnetTimeOut());
				RequestContext.getCurrentContext().set("readTimeout", property.getReadTimeOut()+1000);
			HttpHeaders headers = new HttpHeaders();

			restTemplate.getMessageConverters().set(1,new StringHttpMessageConverter(StandardCharsets.UTF_8));
			MediaType type = MediaType.parseMediaType("application/json;charset=UTF-8");
			headers.setContentType(type);
			headers.add(Constants.HEADER_ACCEPT_KEY, MediaType.APPLICATION_JSON.toString());
			headers.add(Constants.HEADER_TOKEN_KEY, token);
			headers.add(Constants.USER_ID_KEY, userId);
			headers.add(Constants.Url, (String)RequestContext.getCurrentContext().get(Constants.Url));
			headers.add("yysjProductId",yysjProductId);
			//headers.add(Constants.HEADER_OLD_TRACEID_KEY, yysjTraceId);
			headers.add(Constants.HEADER_PARENT_TRACEID_KEY, yysjTraceId);
			Map<String, String> uriVariables = new HashMap<String, String>();
			HttpEntity <String>httpEntity =null;

			ResponseEntity<OtherCommonResult> entity = null;
				httpEntity = new HttpEntity<String>(body,
						headers);
				entity = restTemplate.postForEntity(property.getOtherGateWayUrl(), httpEntity,
						OtherCommonResult.class,new HashMap());

			if (entity != null && entity.getStatusCode() == HttpStatus.OK) {// 调用通道成功
				otherCommonResult = entity.getBody();
			}
			log.info("otherCommonResult:{}",otherCommonResult);

		} catch (Exception ex) {
			log.error("Exception:{}",ex);
			otherCommonResult.setResultCode(Constants.error);
		}
		return otherCommonResult;
	}
}
