package info.aspirecn.iov.yysj.check.info.common;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;
import javax.servlet.http.HttpServletResponse;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.annotation.JsonInclude;
import info.aspirecn.cloud.yysj.commons.lang.BillItemResult;
import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.iov.yysj.check.info.CheckInfo;
import info.aspirecn.iov.yysj.check.info.entity.BillResultObject;
import info.aspirecn.iov.yysj.check.info.entity.CarRoadTransportObject;
import info.aspirecn.iov.yysj.check.info.entity.CheckInfoRequest;
import info.aspirecn.iov.yysj.check.info.entity.CompanyRoadTransportObject;
import info.aspirecn.iov.yysj.check.info.entity.PersonRoadTransportObject;
import info.aspirecn.iov.yysj.check.info.entity.RoadTransportObject;
import info.aspirecn.iov.yysj.check.info.entity.RoadTransportTem;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.gson.Gson;
import com.netflix.zuul.context.RequestContext;
import lombok.extern.slf4j.Slf4j;
@Component
@Slf4j
public class ZuulHelper {
	@Autowired
	private ObjectMapper mapper;
	@Autowired
	Gson gson;
	@Autowired
	StringRedisTemplate stringTemplate;
	@Autowired
	Property property;
	public Boolean hasProcessFlag(RequestContext requestContext) {

        Boolean ret = (Boolean)requestContext.get("process");
        if( ret != null )
        {
            return ret;
        }
        else
        {
            return Boolean.FALSE;
        }
    }

	public void responseHandle(Object responseObject, RequestContext requestContext, boolean isContinue) throws JsonProcessingException{

			String json = JSON.toJSONString(responseObject);
		 requestContext.set("process", isContinue);
		 requestContext.setResponseBody(json);
		 requestContext.getResponse().setCharacterEncoding("utf-8");
		 requestContext.getResponse().setContentType("application/json");
		 requestContext.setSendZuulResponse(false);
		 requestContext.setResponseStatusCode(HttpServletResponse.SC_OK);// 返回码
	}
	//获取请求参数
	public  String getCustomBody(RequestContext requestContext) throws UnsupportedEncodingException, IOException{
		StringBuilder body = new StringBuilder();
	 	BufferedReader bufferedReader = new BufferedReader(
				new InputStreamReader(requestContext.getRequest().getInputStream(), "utf-8")); // 读取参数流
		String nextLine = bufferedReader.readLine();
		while (nextLine != null) {
		    body.append(nextLine);
			nextLine = bufferedReader.readLine();
		}
		String bodyStr = body.toString();
		Map map = gson.fromJson(bodyStr, Map.class);
		Object customBodyObject = map.get("customBody");
		String customBody = mapper.writeValueAsString(customBodyObject);
		return customBody;
	}
	//拆分运单map
	public static  String divYunDan(String customBody) throws JsonProcessingException {
		ObjectMapper objectMapper=new ObjectMapper();


			Map <String,Object> resultMap = new HashMap<String,Object>();
			Map<String, String> map = objectMapper.readValue(customBody, Map.class);
			handle(map,resultMap);
			return objectMapper.writeValueAsString(resultMap);


	}
	public static void handle(Map map,Map<String,Object> resultMap){
		Set<Map.Entry<String,String>> set = map.entrySet();


		for(Map.Entry<String,String> entry :set){
			String key =entry.getKey();
			Object value = entry.getValue();
			String upperKey="";
			if("vin".equals(key)){
				upperKey="VIN";
			}else{
				upperKey = key.substring(0,1).toUpperCase()+key.substring(1);
			}
			if(value instanceof LinkedHashMap){
				Map hashMap = (Map)value;
				Map<String,Object> resultHashMap = new HashMap<String,Object>();
				handle(hashMap,resultHashMap);
				resultMap.put(upperKey,resultHashMap);
			}else if(value instanceof String){
				resultMap.put(upperKey,value);
			}else if(value instanceof ArrayList){
				List<Object> list = new ArrayList<Object>();
				for(int i=0;i<((List) value).size();i++){
					Object listValue = ((List) value).get(i);
					if(listValue instanceof LinkedHashMap){
						Map linkMap = (Map)listValue;
						Map<String,Object> resultHashMap = new HashMap<String,Object>();
						 handle(linkMap,resultHashMap);
						 list.add(resultHashMap);
					}else  if(value instanceof String){
						resultMap.put(upperKey,value);
						list.add(value);
					}
					resultMap.put(upperKey,list);
				}
			}
		}
	}


	//处理信用和云雁返回参数不一致

	public  Object transResponse(String url,String body) throws NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, ClassNotFoundException, InstantiationException {



		if(Constants.RoadTransportUrl.CarRoadTransport.getValue().equals(url)) {
			CarRoadTransportObject carRoadTransportObject = getCarRoadTransportObject(body);
			return carRoadTransportObject;

		}else if(Constants.RoadTransportUrl.PersonRoadTransport.getValue().equals(url)) {
			PersonRoadTransportObject personRoadTransportObject = getPersonRoadTransportObject(body);
			return personRoadTransportObject;

		}else if(Constants.RoadTransportUrl.CompanyRoadTransport.getValue().equals(url)) {
			CompanyRoadTransportObject companyRoadTransportObject = getCompanyRoadTransportObject(body);
			return companyRoadTransportObject;


		}


	return null;
	}


	public  static CarRoadTransportObject getCarRoadTransportObject(String json) {//根据属性名获取上游返回对象属性名
		CarRoadTransportObject carRoadTransportObject = JSONObject.parseObject(json,CarRoadTransportObject.class);
		Map upMap = JSONObject.parseObject(json,Map.class);
		Map<String,String> map=carRoadTransportObject.getMap();
		Set<Map.Entry<String,String>> set = map.entrySet();
		Class classs= carRoadTransportObject.getClass();
		for(Map.Entry<String,String> entry:set){
			try {
				Object upValue = upMap.get(entry.getValue());
				String name = entry.getKey();
				String type = classs.getDeclaredField(name).getType().getTypeName();
				log.info("name:{},type:{}",name,type);
				if ("vehicleTonnage".equals(name)) {
					double d = 0;


					if (upValue instanceof String) {
						d = Double.parseDouble((String) upValue);

					} else if (upValue instanceof Integer || upValue instanceof Double) {
						d = (Double) upValue;
					}

					DecimalFormat df = new DecimalFormat("#0.00");
					String str = df.format(d);
					carRoadTransportObject.setVehicleTonnage(str);
				} else {
					if ("java.lang.String".equals(type)) {

						Method method = classs.getMethod("set" + name.substring(0, 1).toUpperCase() + name.substring(1), Class.forName(type));
						method.invoke(carRoadTransportObject, upValue);
					} else if ("java.lang.Integer".equals(type)) {

						Method method = classs.getMethod("set" + name.substring(0, 1).toUpperCase() + name.substring(1), Class.forName(type));
						if (upValue instanceof String) {

							method.invoke(carRoadTransportObject, Integer.parseInt((String) upValue));
						} else if (upValue instanceof Integer) {
							method.invoke(carRoadTransportObject, upValue);
						}
					}
				}
			}catch (Exception ex){
				log.error("Exception:{}",ex);
			}
		}
		return carRoadTransportObject;

	}



	public  static PersonRoadTransportObject getPersonRoadTransportObject(String json) {//根据属性名获取上游返回对象属性名
		PersonRoadTransportObject personRoadTransportObject = new PersonRoadTransportObject();



		Map upMap = JSONObject.parseObject(json, Map.class);
		Map<String, Object> map = personRoadTransportObject.getMap();
		log.info("map:{}",map);
		Set<Map.Entry<String, Object>> set = map.entrySet();
		Class classs = personRoadTransportObject.getClass();

		for (Map.Entry<String, Object> entry : set) {

			try {


				String name = entry.getKey();

				String type = classs.getDeclaredField(name).getType().getTypeName();
				log.info("name:{},type:{}",name,type);

				if ("java.lang.String".equals(type)) {
					Object upValue = upMap.get(entry.getValue());
					Method method = classs.getMethod("set" + name.substring(0, 1).toUpperCase() + name.substring(1), Class.forName(type));
					method.invoke(personRoadTransportObject, upValue);
				} else if("java.util.List".equals(type)){
					Object upValue = upMap.get(name);

					if(upValue instanceof JSONArray){

						JSONArray list = (JSONArray)upValue;
						Object[] object  = list.stream().toArray();

						//List<PersonRoadTransportObject.QualificationCertificateInfo> list = personRoadTransportObject.getQualificationCertificateInfo();
						if(object !=null) {
							List<PersonRoadTransportObject.QualificationCertificateInfo> qualificationCertificateInfos = new ArrayList<>();
							for (int i=0;i<object.length;i++) {
								Object listDetail = object[i];

								log.info("listDetail:{},instanceof:{}",listDetail,(listDetail instanceof  Map));
								PersonRoadTransportObject.QualificationCertificateInfo qualificationCertificateInfo = new PersonRoadTransportObject.QualificationCertificateInfo();
								if (listDetail instanceof Map) {
									Map mapDetail = (Map) listDetail;


									log.info("mapDetail:{}",mapDetail);
									Map subKeyMap = (Map) entry.getValue();

									Set<Map.Entry<String, String>> qualificationKeySet = subKeyMap.entrySet();

									for (Map.Entry<String, String> qualificationKey : qualificationKeySet) {
										String subName = qualificationKey.getKey();
										Object mapDetailValue = mapDetail.get(qualificationKey.getValue());


										log.info("subName:{},mapDetailValue:{}",subName,mapDetailValue);
										Method method = PersonRoadTransportObject.QualificationCertificateInfo.class.getMethod("set" + subName.substring(0, 1).toUpperCase() + subName.substring(1), String.class);

										method.invoke(qualificationCertificateInfo, mapDetailValue);

									}
								}

								qualificationCertificateInfos.add(qualificationCertificateInfo);

							}
							Collections.sort(qualificationCertificateInfos);
							personRoadTransportObject.setQualificationCertificateInfo(qualificationCertificateInfos);
						}
					}



				}


			} catch (Exception ex) {
				log.error("ex:{}",ex);
			}
		}
		return personRoadTransportObject;
	}



	public  static CompanyRoadTransportObject getCompanyRoadTransportObject(String json) {//根据属性名获取上游返回对象属性名
		CompanyRoadTransportObject companyRoadTransportObject = JSONObject.parseObject(json,CompanyRoadTransportObject.class);
		Map upMap = JSONObject.parseObject(json,Map.class);
		Map<String,String> map=companyRoadTransportObject.getMap();
		Set<Map.Entry<String,String>> set = map.entrySet();
		Class classs= companyRoadTransportObject.getClass();
		for(Map.Entry<String,String> entry:set){
			try {
				Object upValue = upMap.get(entry.getValue());
				String name = entry.getKey();
				String type = classs.getDeclaredField(name).getType().getTypeName();
				log.info("name:{},type:{}",name,type);

					if ("java.lang.String".equals(type)) {

						Method method = classs.getMethod("set" + name.substring(0, 1).toUpperCase() + name.substring(1), Class.forName(type));
						method.invoke(companyRoadTransportObject, upValue);
					} else if ("java.lang.Integer".equals(type)) {

						Method method = classs.getMethod("set" + name.substring(0, 1).toUpperCase() + name.substring(1), Class.forName(type));
						if (upValue instanceof String) {

							method.invoke(companyRoadTransportObject, Integer.parseInt((String) upValue));
						} else if (upValue instanceof Integer) {
							method.invoke(companyRoadTransportObject, upValue);
						}
					}

			}catch (Exception ex){
				log.error("Exception:{}",ex);
			}
		}
		return companyRoadTransportObject;
	}
	//请求参数查询解决
	public  String queryParam(String url,Map<String, String>  map){
		String result = null;
		try{
			CheckInfoRequest checkInfoRequest =new CheckInfoRequest();
			if(Constants.RequestUrl.DRIVERURL.getValue().equals(url)){
				checkInfoRequest.setPerson_name(map.get(Constants.driver_driverNamer));
				checkInfoRequest.setPerson_driverNo(map.get(Constants.driver_driverLicenseNumber));
				checkInfoRequest.setPerson_QualificationCertificate(map.get(Constants.driver_qualificationCertificate));
			}else if(Constants.RequestUrl.CARURL.getValue().equals(url)){
				checkInfoRequest.setCar_vehicleNumber(map.get(Constants.car_vehicleNumber));
				checkInfoRequest.setCar_vehiclePlateColorCode(map.get(Constants.car_vehiclePlateColorCode));
			}else if(Constants.RequestUrl.BILLWAYURL.getValue().equals(url)){
				checkInfoRequest.setBill_shippingNoteNumber(map.get("shippingNoteNumber"));
				Object vehicleInfo = map.get("vehicleInfo");
				if(vehicleInfo !=null && vehicleInfo instanceof  LinkedHashMap){
					Map vehicleInfoMap = (Map)vehicleInfo;
					String vehicleNumber=(String)vehicleInfoMap.get("vehicleNumber");
					checkInfoRequest.setBill_vehicleNumber(vehicleNumber);
				}

			}
			result = mapper.writeValueAsString(checkInfoRequest);
		} catch (IOException e) {
			log.error("Exception:{}",e);
		}
		return result;
	}
	public  int getType(String url){
			if(Constants.RequestUrl.DRIVERURL.getValue().equals(url)){
				return 2;
			}else if(Constants.RequestUrl.CARURL.getValue().equals(url)){
				return 1;
			}else if(Constants.RequestUrl.BILLWAYURL.getValue().equals(url)){
				return 3;
			}else if(Constants.OtherRquestUrl.LIVINGURL.getValue().equals(url)){
				return 4;
			}else if(Constants.OtherRquestUrl.IDLENTITYVERIFICATION.getValue().equals(url)){
				return 5;
			}else if(Constants.RoadTransportUrl.CarRoadTransport.getValue().equals(url)){
				return 10;
			}else if(Constants.RoadTransportUrl.PersonRoadTransport.getValue().equals(url)){
				return 11;
			}else if(Constants.RoadTransportUrl.CompanyRoadTransport.getValue().equals(url)){
				return 12;
			}else if (Constants.VehicleTrajectoryUrl.HISTORY_POSITION.getValue().equals(url)) {
				return 13;
			}else if (Constants.RequestUrl.VEHICLE_POSITION_CONSISTENCY_CHECK.getValue().equals(url)) {
				return 14;
			}

		return 0;
	}
	//请求参数透传参数
	/*public  String tcParam(String url,String productId,Map<String, String>  map){
		String result = null;
		try{
			CheckInfo checkInfo =new CheckInfo();
			//Map<String, String>  map= mapper.readValue(customBody, Map.class);
			Map<String, String>  tcCustomMap = new HashMap<String,String>();
			if("/info_check/driverInfo.do".equals(url)||"/info_check/carInfo.do".equals(url)){

				String paramStr = property.getCarMap().get(productId);
				String[] params = paramStr.split("-");
				for(String param:params){
					tcCustomMap.put(param,map.get(param));
				}
				return mapper.writeValueAsString(tcCustomMap);
			}else if("/info_check/waybill.do".equals(url)){
				checkInfo.setBill_shippingNoteNumber(map.get("ShippingNoteNumber"));
				Object vehicleInfo = map.get("VehicleInfo");
				if(vehicleInfo !=null && vehicleInfo instanceof  LinkedHashMap){
					Map vehicleInfoMap = (Map)vehicleInfo;
					String vehicleNumber=(String)vehicleInfoMap.get("VehicleNumber");
					checkInfo.setBill_vehicleNumber(vehicleNumber);
				}

			}
			result = mapper.writeValueAsString(checkInfo);
		} catch (IOException e) {
			log.error("Exception:{}",e);
		}
		return result;
	}*/


	public static void main(String[] args) throws InvocationTargetException, NoSuchMethodException, ClassNotFoundException, InstantiationException, IllegalAccessException {
		String info="{\"result\":\"1\",\"exceptionInformation\":{\"code\":0,\"resultList\":null},\"detail\":\"{\\\"enterpriseName\\\":\\\"嘉兴万宇物流有限公司\\\",\\\"permitNumber\\\":\\\"330401011867\\\",\\\"businessScope\\\":\\\"货运中介,道路普通货物运输\\\",\\\"permitGrantDate\\\":\\\"20180813\\\",\\\"periodStartDate\\\":\\\"20180813\\\",\\\"periodEndDate\\\":\\\"20220813\\\",\\\"certificationUnit\\\":\\\"嘉兴市道路运输管理局\\\",\\\"operatingStatus\\\":\\\"1\\\"}\"}\n";
						ZuulHelper zuulHelper = new ZuulHelper();
		BillItemResult billItemResult = JSONObject.parseObject(info,BillItemResult.class);
		if("1".equals(billItemResult.getResult())) {//上游返回一致
			String detail = billItemResult.getDetail();
			Object object = zuulHelper.transResponse(Constants.RoadTransportUrl.CompanyRoadTransport.getValue(), detail);
			log.info("object:{}",JSONObject.toJSONString(object));
		}



	}




}

