package info.aspirecn.iov.yysj.check.info.entity;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

@Setter
@Getter
@Slf4j
public class CarRoadTransportObject{
	@JSONField(serialize=false)
	private Map<String,String> map;

	private String vehicleNumber;//车辆牌照号
	private String vehiclePlateColorCode;//	车牌颜色代码
	private String vin;//车辆识别代号。
	private Integer vehicleLength;//车辆长度
	private Integer vehicleWidth;//车辆宽度
	private Integer vehicleHigh;//车辆高度

	private Integer tractionTonnage;//车辆准牵引总质量
	private String businessState;//车辆营运状态
	private String vehicleType;//车辆类型

	private String vehicleEnergyType;//车辆能源类型	 上游没有返回
	private String vehicleTonnage;//车辆核定载质量状态
	private String roadTransportCertificateNumber;//道路运输证号
	
	private String roadTransportCertificateValidPeriodFrom;//道路运输证有效期自
	private String roadTransportCertificateValidPeriodTo;//道路运输证有效期至
	private String roadTransportLicenseIssueOrganName;//道路运输证发证机构名称
	
	
	private String entName;//企业名称
	private String businessScopeDesc;//车辆经营范围	
	private String permitNumber;//道路运输经营许可证编号   上游没有返回
	
	private String unifiedSocialCreditIdentifier;//道路运输经营许可证编号  上游没有返回

	public CarRoadTransportObject() {
		map = new HashMap<>();
		
		map.put("vehiclePlateColorCode", "licensePlateTypeCode");
		map.put("vin", "vinNo");
		map.put("vehicleHigh", "vehicleHeight");
		map.put("vehicleTonnage","vehicleTonnage");
		map.put("tractionTonnage", "vehicleMaximumTractionWeight");
		map.put("vehicleType", "vehicleClassification");
		map.put("vehicleEnergyType", "fuelType");

		map.put("roadTransportCertificateValidPeriodFrom", "periodStartDate");
		map.put("roadTransportCertificateValidPeriodTo", "periodEndDate");
		
		map.put("roadTransportLicenseIssueOrganName", "certificationUnit");
		map.put("entName", "vehicleCorporationName");
		map.put("businessScopeDesc", "businessScope");
		map.put("unifiedSocialCreditIdentifier", "organizationCode");
	}



}
