package info.aspirecn.iov.yysj.check.info.entity;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;

import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;

@Getter
@Setter
@Slf4j
public class PersonRoadTransportObject{
	@JSONField(serialize=false)
	Map<String,Object> map;
	public PersonRoadTransportObject() {
		map = new HashMap<>();
		map.put("gender", "gender");
		map.put("driverName", "nameOfPerson");
		map.put("drivingLicense", "identityDocumentNumber");
		Map<String,String> subMap = new HashMap<String,String>();
		subMap.put("qualificationCertificateLicenseIssueOrganName","certificationUnit");
		subMap.put("qualificationCertificate","qualificationCertificateNumber");
		subMap.put("certificateState","certificateState");
		subMap.put("certificateFirstIssueDate","licenseInitialReleaseDate");


		subMap.put("qualificationCertificateValidPeriodTo","periodEndDate");
		subMap.put("qualificationCertificateValidPeriodFrom","periodStartDate");
		subMap.put("workTypeCode","qualificationCertificateCategoryCode");
		map.put("qualificationCertificateInfo",subMap);
	}

	
	private String driverName;//姓名
	private String drivingLicense;//	身份证号

	private String gender;//性别

	private List<QualificationCertificateInfo> qualificationCertificateInfo;
	@Data
    public static class QualificationCertificateInfo implements Comparable{
		private String qualificationCertificateLicenseIssueOrganName;//从业资格证发证机构名称
		private String qualificationCertificate;//从业资格证号
		private String certificateState;//证照状态  上游没有返回
		private String certificateFirstIssueDate;//从业资格证初领时间
		private String qualificationCertificateValidPeriodFrom;//从业资格证有效期自

		private String qualificationCertificateValidPeriodTo;//从业资格证有效期至
		private String workTypeCode;//从业资格类别

		@Override
		public int compareTo(Object o) {
			if(o instanceof QualificationCertificateInfo){
				QualificationCertificateInfo qualificationCertificateInfo = (QualificationCertificateInfo)o;
				return this.certificateFirstIssueDate.compareTo(qualificationCertificateInfo.getCertificateFirstIssueDate());
			}
			return 0;
		}
	}

	

}
