package info.aspirecn.iov.yysj.check.info.entity;



import com.alibaba.fastjson.annotation.JSONField;
import info.aspirecn.iov.yysj.check.info.common.NonFixedValueAttr;
import lombok.Data;
import javax.validation.constraints.NotBlank;

@Data
public class WayBill {

    @NotBlank
    @JSONField(name = "OriginalDocumentNumber")
    private String originalDocumentNumber;
    @NotBlank
    @JSONField(name = "ShippingNoteNumber")
    private String shippingNoteNumber;
    @NotBlank

     @NonFixedValueAttr(isDate=true,dateFormatString="yyyyMMddHHmmss")
    @JSONField(name = "SendToProDateTime")
   private String sendToProDateTime;
   //  Carrier	String	是	网络货运经营者名称
   @NotBlank
   @JSONField(name = "Carrier")
   private String carrier;
   // UnifiedSocialCreditIdentifier	String	是	统一社会信用代码
   @NotBlank
   @JSONField(name = "UnifiedSocialCreditIdentifier")
    private String unifiedSocialCreditIdentifier;
    //PermitNumber	String	是	网络货运经营者的道路运输经营许可证编号，网络货运经营者整合车辆全部为总质量4.5吨及以下普通货运车辆的，可填“企业所在地行政区划代码+000000”。
    @NotBlank
    @JSONField(name = "PermitNumber")
    private String permitNumber;
   // ConsignmentDateTime	String	是	网络货运经营者信息系统正式成交生成运单的日期时间。YYYYMMDDhhmmss
   @NonFixedValueAttr(isDate=true,dateFormatString="yyyyMMddHHmmss")
   @JSONField(name = "ConsignmentDateTime")
   private String consignmentDateTime;
    //BusinessTypeCode	String	是	业务类型代码，代码集参见wlhy.mot.gov.cn。
    @NotBlank
    @JSONField(name = "BusinessTypeCode")
    private String businessTypeCode;
    //DespatchActualDateTime	String	是	货物装车后的发车时间。YYYYMMDDhhmmss
    @NonFixedValueAttr(isDate=true,dateFormatString="yyyyMMddHHmmss")
    @JSONField(name = "DespatchActualDateTime")
    private String despatchActualDateTime;
    //GoodsReceiptDateTime	String	是	货物运到后的签收时间。YYYYMMDDhhmmss
    @NonFixedValueAttr(isDate=true,dateFormatString="yyyyMMddHHmmss")
    @JSONField(name = "GoodsReceiptDateTime")
    private String goodsReceiptDateTime;
    //ConsignorInfo	String	是	托运人信息
    @NotBlank
    @JSONField(name = "ConsignorInfo")
    private String consignorInfo;
    //Consignor	String	是	托运人名称
    @NotBlank
    @JSONField(name = "Consignor")
    private String consignor;
   // ConsignorID	String	是	托运人统一社会信用代码或个人证件号
   @NotBlank
   @JSONField(name = "ConsignorID")
   private String consignorID;
    //PlaceOfLoading	String	否	实际装货的地点。
    @JSONField(name = "consignorID")
   private String placeOfLoading;
    //CountrySubdivisionCode	String	是	参照最新版《中华人民共和国行政区划代码》（GB/T 2260-2017），精确到区县。
    @NotBlank
    @JSONField(name = "CountrySubdivisionCode")
    private String countrySubdivisionCode;
    //ConsigneeInfo	String	是	收货方信息
    @NotBlank
    @JSONField(name = "ConsigneeInfo")
    private String consigneeInfo;
    //Consignee	String	是	收货方名称
    @NotBlank
    @JSONField(name = "Consignee")
    private String consignee;
    //ConsigneeID	String	是	收货方统一社会信用代码或个人证件号码
    @NotBlank
    @JSONField(name = "ConsigneeID")
    private String consigneeID;
   // GoodsReceiptPlace	String	否	收货地址
   @JSONField(name = "GoodsReceiptPlace")
    private String goodsReceiptPlace;
    //TotalMonetaryAmount	String	是	托运人与网络货运经营者签订运输合同确定的运费金额，货币单位为人民币（元），保留3位小数，如整数的话，以.000填充。如是一笔业务分几辆车运，需将托运人针对这笔业务付给网络货运经营者的运输费用分摊到每辆车上。
    @NotBlank
    @JSONField(name = "TotalMonetaryAmount")
    private String totalMonetaryAmount;
    //VehicleInfo	String	是	车辆信息
    @NotBlank
    @JSONField(name = "VehicleInfo")
    private String vehicleInfo;
    //VehiclePlateColorCode	String	是	车牌颜色代码
    @NotBlank
    @JSONField(name = "Carrier")
    private String vehiclePlateColorCode;
    //VehicleNumber	String	是	车辆牌照号
    @NotBlank
    @JSONField(name = "Carrier")
    private String vehicleNumber;
    //Driver	String	是	驾驶员，如运输过程中有多个驾驶员，可循环。
    @NotBlank
    @JSONField(name = "Driver")
    private String driver;
    //DriverName	String	是	驾驶员姓名。
    @NotBlank
    @JSONField(name = "DriverName")
    private String driverName;
    //DrivingLicense	String	是	机动车驾驶证编号，根据机动车驾驶证填写。
    @NotBlank
    @JSONField(name = "DrivingLicense")
    private String drivingLicense;
   // GoodsInfo	String	是	货物信息，如一车货有不同货物，则可循环。
   @NotBlank
   @JSONField(name = "GoodsInfo")
   private String goodsInfo;
    //DescriptionOfGoods	String	是	货物名称
    @NotBlank
    @JSONField(name = "DescriptionOfGoods")
    private String descriptionOfGoods;
    //CargoTypeClassificationCode	String	是	货物类型分类代码
    @NotBlank
    @JSONField(name = "CargoTypeClassificationCode")
    private String cargoTypeClassificationCode;
    //GoodsItemGrossWeight	String	是	货物项毛重，重量单位以KGM千克填写数值，保留3位小数，如整数的话，以.000填充。小数点不计入总长。如是轻泡货等货物，请估算重量。如一笔业务分几辆车运，需报送每辆车实际运输的货物重量。
    @NotBlank
    @JSONField(name = "GoodsItemGrossWeight")
    private String goodsItemGrossWeight;
    //Cube	String	否	体积，体积单位以DMQ立方米填写数值，保留4位小数，如整数的话，以.0000填充。小数点不计入总长。
    @NotBlank
    @JSONField(name = "Cube")
    private String cube;
    //TotalNumberOfPackages	String	否	总件数
    @NotBlank
    @JSONField(name = "TotalNumberOfPackages")
    private String totalNumberOfPackages;
    //ActualCarrierInfo	String	是	实际承运人信息
    @NotBlank
    @JSONField(name = "ActualCarrierInfo")
    private String actualCarrierInfo;
    //ActualCarrierName	String	是	必填，与网络货运经营者签订运输合同，实际完成运输的经营者。取得道路运输经营许可证的个体运输业户，直接填写“许可证上的业户名称”；其他情况填写“运输公司名称（实际承运驾驶员姓名）”。
    @NotBlank
    @JSONField(name = "ActualCarrierName")
    private String actualCarrierName;
    //ActualCarrierBusinessLicense	String	是	必填，实际承运人的道路运输经营许可证编号，网络货运经营者整合车辆全部为总质量4.5吨及以下普通货运车辆的，可填“车籍地6位行政区域代码+000000”。
    @NotBlank
    @JSONField(name = "ActualCarrierBusinessLicense")
    private String actualCarrierBusinessLicense;
    //ActualCarrierID	String	是	实际承运人统一社会信用代码或证件号码
    @NotBlank
    @JSONField(name = "ActualCarrierID")
    private String actualCarrierID;
    //InsuranceInformation	String	是	保险信息
    @NotBlank
    @JSONField(name = "InsuranceInformation")
    private String insuranceInformation;
    //PolicyNumber	String	是	保险单号，未投保的，可填none。
    @NotBlank
    @JSONField(name = "PolicyNumber")
    private String policyNumber;
    //InsuranceCompany	String	是	保险公司名称，代码集参见wlhy.mot.gov.cn。未投保的，可填“无”。
    @NotBlank
    @JSONField(name = "InsuranceCompany")
    private String insuranceCompany;
    //Remark	String	否	备注
    @JSONField(name = "Remark")
    private String remark;
    //CheckRange	String	否	校验范围,默认不填，按照用户在校验系统后台设定的校验项进行校验；如填写则按照填写项进行校验；填写多项时以半角逗号隔开。*/
    @JSONField(name = "CheckRange")
   private String  checkRange;
}
