package info.aspirecn.iov.yysj.check.info.pre;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.netflix.zuul.ZuulFilter;
import com.netflix.zuul.context.RequestContext;
import info.aspirecn.cloud.yysj.commons.lang.Constants;
import info.aspirecn.iov.yysj.check.info.common.CommonUtil;
import info.aspirecn.iov.yysj.check.info.entity.BillResultObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.netflix.zuul.filters.support.FilterConstants;
import java.io.IOException;
@Slf4j
public class ResultFilter extends ZuulFilter {
    @Autowired
    private ObjectMapper mapper;

    @Override
    public boolean shouldFilter() {
    	return true;
    }

    @Override
    public Object run() {
        RequestContext requestContext = RequestContext.getCurrentContext();
        String responseBody = requestContext.getResponseBody();
        try {
            BillResultObject billResultObject = mapper.readValue(responseBody,BillResultObject.class);
            String traceId = (String)requestContext.get(Constants.HEADER_TRACEID_KEY);
            billResultObject.setTraceId(traceId);
            requestContext.getRequest().setAttribute("resultCode",billResultObject.getResultCode());
        } catch (IOException e) {
            log.info("解析数据异常:{}",e);
        }
        return null;

    }

    @Override
    public String filterType() {
        return FilterConstants.PRE_TYPE;
    }

    @Override
    public int filterOrder() {
        return FilterConstants.SERVLET_30_WRAPPER_FILTER_ORDER + 7;
    }

}
